unit Report;

interface

//uses Classes, Forms, Dialogs, Printers,
//     League, ReportDialog, LadderDialog;

//procedure DoReportLeague(LeagueTitle: string; LeaguePoints: TStringList; LeagueList: TLeagueList; MemberDBExists: Boolean; Application: TApplication; Screen: TScreen; Printer: TPrinter; OwnerForm: TForm; ReportForm: TReportForm; LadderForm: TLadderForm; PrintDialog: TPrintDialog; SaveDialog: TSaveDialog);

implementation
(*
uses SysUtils, Graphics, Controls, Math,
    Utility, ZoomReport, Scoreboard;

// Called by BuildTeamLadder
function CompareTeams(Item1, Item2: Pointer): Integer;
begin
    Result := StrToIntDef(TZRow(Item2)[2].Text, 0) - StrToIntDef(TZRow(Item1)[2].Text, 0);
//    if (LeaguePoints.Count < 1) and (StrToIntDef(LeaguePoints[0], 0) < StrToIntDef(LeaguePoints[1], 0)) then Result := -Result;
    if Result = 0 then
        Result := StrToIntDef(TZRow(Item2)[3].Text, 0) - StrToIntDef(TZRow(Item1)[3].Text, 0);
end;

// Called by BuildSoloLadder
function CompareSolos(Item1, Item2: Pointer): Integer;
begin
    Result := StrToIntDef(TZRow(Item2)[3].Text, 0) - StrToIntDef(TZRow(Item1)[3].Text, 0);
    if Result = 0 then
        Result := Round(100 * StrToFloat(TZRow(Item2)[4].Text) - StrToFloat(TZRow(Item1)[4].Text));
end;

// Called by BuildGamesList
function CompareGames(Item1, Item2: Pointer): Integer;
begin
    Result := StrToIntDef(TStringList(Item2)[2], 0) - StrToIntDef(TStringList(Item1)[2], 0);
    if Result = 0 then
        Result := StrToIntDef(TStringList(Item2)[1], 0) - StrToIntDef(TStringList(Item1)[1], 0);
end;

// Called by BuildGameGrid
function CompareGrid(Item1, Item2: Pointer): Integer;
begin
    Result := StrToIntDef(TZRow(Item2)[TZRow(Item2).Count - 1].Text, 0) -
              StrToIntDef(TZRow(Item1)[TZRow(Item1).Count - 1].Text, 0);
end;

// Show various reports, on various output devices.
procedure DoReportLeague(LeagueTitle: string; LeaguePoints: TStringList; LeagueList: TLeagueList; MemberDBExists: Boolean; Application: TApplication; Screen: TScreen; Printer: TPrinter; OwnerForm: TForm; ReportForm: TReportForm; LadderForm: TLadderForm; PrintDialog: TPrintDialog; SaveDialog: TSaveDialog);

var reports: TZoomReports;
    From, Too: TDateTime;

    // Bubblesort a list, using the given Compare function.
    // Partly nicked from Classes.pas TList.Sort and QuickSort, to work around a bug in Delphi's QuickSort.
    procedure BubbleSort(SortList: TList; Compare: TListSortCompare);
    var I, J: Integer;
    begin
        if (SortList = nil) or (SortList.Count = 0) then Exit;
        for I := 0 to SortList.Count - 1 do
            for J := I to SortList.Count - 1 do
                if Compare(SortList[I], SortList[J]) > 0 then
                    SortList.Exchange(I, J);
    end;

    function LastGameDate: TDateTime;
    begin
        DM.LeagueTable.Close;
        DM.LeagueTable.IndexFieldNames := 'Game;ID';
        DM.LeagueTable.Open;
        DM.LeagueTable.Last;
        if DM.LeagueTable.Bof then begin
            Result := Date;
        end else begin
            Result := Int(DM.LeagueTable.FieldByName('Game').AsDateTime);
        end;
        DM.LeagueTable.Close;
        DM.LeagueTable.IndexFieldNames := '';
    end;

    // Display on the scoreboard the current overall league ladder, one line per team,
    // showing how many points each team has total.
    procedure BuildTeamLadder(ScaleGames, WithinDateRange: Boolean; From, Too: TDateTime);
    var i, j: Integer;
        headings:   string;
        barcol:     Integer;            // column on which we are going to draw the horizontal bar chart
        report:     TZoomReport;
        score, points, count: Integer;  // used to sum up a team's total score, total league points, and number of games played
        countlist:  TStringList;        // used to track number of games each team has played, for scaling
        mode:       Integer;            // used in calculating mode; i.e. number of games which most teams have played
        countval, modeval: string;      // used in calculating mode
    begin
        if (LeaguePoints.Count = 0) or (StrToIntDef(LeaguePoints[0], 0) = 0) then begin
            headings := 'Rank,Team,,"Total score",Games';
            barcol   := 3;
        end else begin
            headings := 'Rank,Team,Points,"Total score",Games';
            barcol   := 2;
        end;

        if WithinDateRange then
            report := reports.Add(LeagueTitle + ' Team Ladder from ' + DateToStr(From) + ' to ' + DateToStr(Too), headings, 'center,left,right,right,right')
        else
            report := reports.Add(LeagueTitle + ' Team Ladder to ' + DateToStr(LastGameDate), headings, 'center,left,right,right,right');

        countlist := TStringList.Create;
        try
            DM.LeagueTable.Open;

            for i := 0 to LeagueList.Count - 1 do begin  // loop through each League team, and create a StatsTable entry for it.
                report.Rows.Add(TZRows.Create);

                report.Rows[i].Add('0');  // put in a temporary Rank

                report.Rows[i].Add(LeagueList[i].BuildTeamName);  // set up team name

                DM.LeagueTable.Filter := 'ID = ' + Format('%4.4d', [LeagueList[i].TeamID]);
                DM.LeagueTable.Filtered := True;
                DM.LeagueTable.First;
                count := 0;
                score := 0;
                points := 0;
                while not DM.LeagueTable.EOF do begin
                    if not WithinDateRange or ((DM.LeagueTable.FieldByName('Game').AsDateTime >= From) and
                                               (DM.LeagueTable.FieldByName('Game').AsDateTime <= Too)) then begin
                        Inc(count);
                        score := score + DM.LeagueTable.FieldByName('Score').AsInteger;
                        points := points + DM.LeagueTable.FieldByName('Points').AsInteger;
                    end;
                    DM.LeagueTable.Next;
                end;
                if (LeaguePoints.Count = 0) or (StrToIntDef(LeaguePoints[0], 0) = 0) then
                    report.Rows[i].Add('')                // league points scored
                else
                    report.Rows[i].Add(IntToStr(points)); // league points scored
                report.Rows[i].Add(IntToStr(score));      // totalled game scores
                report.Rows[i].Add(IntToStr(count));      // total games played

                countlist.Add(Format('%.3d', [count]));
            end;  // for each team in LeagueList

            countlist.Sort;
            if ScaleGames and (countlist[0] <> countlist[countlist.Count - 1]) then begin  // Find the mode, and add scaled columns.
                count    := 0;
                mode     := 0;
                countval := '000';
                modeval  := '001';
                for i := 0 to countlist.Count - 1 do begin
                    if countlist[i] = '000' then Continue;
                    if countlist[i] = countval then begin
                        Inc(count);
                        if mode <= count then begin  // Note that the "<=" instead of just "<" ensures that if there are several values with the same count, the highest of these values will be chosen.
                            mode := count;
                            modeval := countval;
                        end;
                    end else begin
                        count := 1;
                        countval := countlist[i];
                    end;
                end;
                if (LeaguePoints.Count > 0) and (StrToIntDef(LeaguePoints[0], 0) <> 0) then
                    report.Columns.Add('Scaled points', 'right');

                report.Columns.Add('Scaled score', 'right');
                for i := 0 to report.Rows.Count - 1 do begin
                    if (StrToIntDef(modeval, 0) <> StrToIntDef(Trim(report.Rows[i][4].Text), 0)) and (StrToIntDef(report.Rows[i][4].Text, 0) > 0) then begin
                        if (LeaguePoints.Count > 0) and (StrToIntDef(LeaguePoints[0], 0) <> 0) then
                            report.Rows[i].Add(IntToStr(StrToIntDef(report.Rows[i][2].Text, 0) * StrToIntDef(modeval, 0) div StrToIntDef(report.Rows[i][4].Text, 1)));

                        report.Rows[i].Add(IntToStr(StrToIntDef(report.Rows[i][3].Text, 0) * StrToIntDef(modeval, 0) div StrToIntDef(report.Rows[i][4].Text, 1)));
                    end else begin
                        if (LeaguePoints.Count > 0) and (StrToIntDef(LeaguePoints[0], 0) <> 0) then
                            report.Rows[i].Add('');

                        report.Rows[i].Add('');
                    end;
                end;
            end;  // if scalegames

            BubbleSort(report.Rows, CompareTeams);
            for i := 0 to report.Rows.Count - 1 do begin  // loop through each row
                report.Rows[i][0].Text := IntToStr(i + 1);  // set Ranks
                for j := 0 to report.Rows[i].Count - 1 do
                    report.Rows[i][j].BarCell := barcol;
            end;
        finally
            DM.LeagueTable.Filtered := False;
            DM.LeagueTable.Close;
            countlist.Free;
        end;
    end;

    procedure BuildSoloLadder(DropWorst, DropBest: Integer; PercentGames, WithinDateRange: Boolean; From, Too: TDateTime);
    var i, j: Integer;
        headings, alignments: string;
        report: TZoomReport;
        buttonlist, scoreslist, rankslist: TStringList;
        low, high: Integer;
        s: string;
        score, rank, countscores, countranks: Integer;
    begin
        if (DropWorst = 0) and (DropBest = 0) then begin
            headings   := 'Rank,Player,Team,"Average Score","Average Rank",Games';
            alignments := 'center,left,left,right,right,right';
        end else begin
            headings   := 'Rank,Player,Team,"Average Score","Average Rank",Games,Dropped';
            alignments := 'center,left,left,right,right,right,right'
        end;

        if WithinDateRange then
            report := reports.Add(LeagueTitle + ' Solo Ladder from ' + DateToStr(From) + ' to ' + DateToStr(Too), headings, alignments)
        else
            report := reports.Add(LeagueTitle + ' Solo Ladder to ' + DateToStr(LastGameDate), headings, alignments);

        buttonlist := TStringList.Create;
        scoreslist := TStringList.Create;
        rankslist  := TStringList.Create;
        try
            DM.LeagueTable.Open;
            DM.LeagueTable.First;
            while not DM.LeagueTable.EOF do begin
                s := DM.LeagueTable.FieldByName('ID').AsString;
                if (Length(s) = 7) and (s[4] in ['+', '-', '%']) and (buttonlist.IndexOf(s) = -1) then  // if it's a button id, and it's not already in the list,
                    buttonlist.Add(s);  // add it to the list of button id's
                DM.LeagueTable.Next;
            end;

            for i := 0 to buttonlist.Count - 1 do begin  // for each unique button id,
                report.Rows.Add(TZRow.Create);

                report.Rows[i].Add('0');  // put in a temporary Rank
                report.Rows[i].Add(LeagueList.FindID(buttonlist[i], MemberDBExists, DM));  // set up player name
                report.Rows[i].Add(LeagueList.FindTeamByButton(buttonlist[i]));  // set up team name

                DM.LeagueTable.Filter := 'ID = ''' + buttonlist[i] + '''';
                DM.LeagueTable.Filtered := True;
                DM.LeagueTable.First;
                scoreslist.Clear;
                rankslist.Clear;
                while not DM.LeagueTable.EOF do begin
                    if not WithinDateRange or ((DM.LeagueTable.FieldByName('Game').AsDateTime >= From) and
                                               (DM.LeagueTable.FieldByName('Game').AsDateTime <= Too)) then begin
                        scoreslist.Add(Format('%9.9d', [DM.LeagueTable.FieldByName('Score').AsInteger]));  // note that these are left-padded with 0's to ensure that they sort correctly
                        rankslist.Add( Format('%9.9d', [DM.LeagueTable.FieldByName('Points').AsInteger]));
                    end;
                    DM.LeagueTable.Next;
                end;
                scoreslist.Sort;
                rankslist.Sort;
                if PercentGames then begin
                    low  := DropWorst * scoreslist.Count div 100;
                    high := scoreslist.Count - (DropBest  * scoreslist.Count div 100) - 1;
                end else begin
                    low  := DropWorst;
                    high := scoreslist.Count - DropBest - 1;
                end;
                score := 0;
                rank := 0;
                countscores := 0;
                countranks := 0;
                if (scoreslist.Count > 0) and (low > high) then begin  // there are scores in the list, but we've been told to drop them
                    if scoreslist.Count mod 2 = 0 then begin  // there are an even number of scores: just grab the middle two and average them
                        countscores := 2;
                        countranks := 2;
                        score := (StrToInt(scoreslist[scoreslist.Count div 2 - 1]) + StrToInt(scoreslist[scoreslist.Count div 2])) div 2;
                        rank  := (StrToInt(rankslist[rankslist.Count div 2 - 1])   + StrToInt(rankslist[rankslist.Count div 2])) div 2;
                    end else begin  // there are an odd number of scores: grab the middle one
                        countscores := 1;
                        countranks := 1;
                        score := StrToInt(scoreslist[scoreslist.Count div 2]);
                        rank  := StrToInt(rankslist[rankslist.Count div 2]);
                    end;
                end else  // there are no scores in the list, or there are enough scores to calculate an average, even after we've dropped games as requested
                    for j := low to high do begin
                        score := score + StrToInt(scoreslist[j]);
                        Inc(countscores);
                        rank  := rank  + StrToInt(rankslist[j]);
                        if StrToInt(rankslist[j]) > 0 then  // if the rank is 0, we don't increment, as this is not a valid rank
                            Inc(countranks);
                    end;
                if countscores = 0 then begin
                    report.Rows[i].Add('0');                              // average score
                    report.Rows[i].Add('0.00');                           // average rank
                    report.Rows[i].Add('0');                              // total games played
                    if (DropWorst > 0) or (DropBest > 0) then
                        report.Rows[i].Add('0');                          // games dropped
                end else begin
                    report.Rows[i].Add(IntToStr(score  div countscores)); // average score
                    if countranks > 0 then
                        report.Rows[i].Add(Format('%.2f', [rank / countranks]))  // average rank
                    else
                        report.Rows[i].Add(' ');                         // no valid ranks were found; fill in a blank for average rank
                    report.Rows[i].Add(IntToStr(scoreslist.Count));       // total games played
                    if (DropWorst > 0) or (DropBest > 0) then
                        report.Rows[i].Add(IntToStr(scoreslist.Count - countscores));  // games dropped
                end;

                for j := 0 to report.Rows[i].Count - 1 do
                    report.Rows[i][j].BarCell := 3;
            end;  // for i

            BubbleSort(report.Rows, CompareSolos);
            for i := 0 to report.Rows.Count - 1 do  // loop through each row
                report.Rows[i][0].Text := IntToStr(i + 1);  // set Ranks
        finally
            DM.LeagueTable.Filtered := False;
            DM.LeagueTable.Close;
            buttonlist.Free;
            scoreslist.Free;
            rankslist.Free;
        end;
    end;

    procedure SetTeamColour(Game: TDateTime; ID: Integer; Colour: string);
    begin
        with DM.LeagueTable do begin
            if Locate('Game;ID', VarArrayOf([Game, Format('%4.4d', [ID])]), []) or
               Locate('ID;Game', VarArrayOf([Format('%4.4d', [ID]), Game]), [])
            then begin
                Edit;
                FieldByName('Pack').AsString := Colour;
                Post;
            end;
        end;
    end;

    // Return a colour for a team in a given game.
    function GetTeamColour(Game: TDateTime; teamnum: Integer): TColor;
    var oldpos: Integer;
        oldeof: Boolean;
        red, green, blue, yellow: Integer;
        colour: string;
    begin
        Result := clNone;
        with DM.LeagueTable do begin
            red := 0;  green := 0;  blue := 0;  yellow := 0;
            oldpos := RecNo;
            oldeof := EOF;

            if (Locate('Game;ID', VarArrayOf([Game, Format('%4.4d', [teamnum])]), []) or
                Locate('ID;Game', VarArrayOf([Format('%4.4d', [teamnum]), Game]), [])) and
               (Length(FieldByName('Pack').AsString) > 0)
            then begin
                case UpperCase(FieldByName('Pack').AsString)[1] of
                    'R': Result := $02B0B0FF;  // red
                    'G': Result := $02A0FFA0;  // green
                    'B': Result := $02FFD0A0;  // blue
                    'Y': Result := $0290FFFF;  // yellow
                end;
                RecNo := oldpos;
                if oldeof then Next;  // cause EOF to be set back to True
                Exit;
            end;

            Locate('Game', Game, []);
            while not EOF and (FieldByName('Game').AsDateTime = Game) do begin
                if (FieldByName('ID2').AsString = Format('%4.4d', [teamnum])) then begin
                    colour := FieldByName('Pack').AsString;
                    if Length(colour) > 0 then case UpperCase(colour)[1] of
                        'R': Inc(red);
                        'G': Inc(green);
                        'B': Inc(blue);
                        'Y': Inc(yellow);
                    end;
                end;
                Next;
            end;
        end;  // with DM.LeagueTable
                                                                                        // B G R
        if      (red > green)    and (red > blue)     and (red > yellow)   then begin
            Result := $02B0B0FF;  // red
            SetTeamColour(Game, teamnum, 'Red');
        end
        else if (green > red)    and (green > blue)   and (green > yellow) then begin
            Result := $02A0FFA0;  // green
            SetTeamColour(Game, teamnum, 'Grn');
        end
        else if (blue > red)     and (blue > green)   and (blue > yellow)  then begin
            Result := $02FFD0A0;  // blue
            SetTeamColour(Game, teamnum, 'Blu');
        end
        else if (yellow > red)   and (yellow > green) and (yellow > blue)  then begin
            Result := $0290FFFF;  // yellow
            SetTeamColour(Game, teamnum, 'Yel');
        end
        else if (red = blue)     and (red > green)    and (red > yellow)   then Result := $02FFB0FF  // red + blue
        else if (red = yellow)   and (red > green)    and (red > blue)     then Result := $02A0D0FF  // red + yellow
        else if (green = blue)   and (green > red)    and (green > yellow) then Result := $02FFFFA0  // green + blue
        else if (green = yellow) and (green > red)    and (green > blue)   then Result := $02A0FFE0  // green + yellow
        else if (blue = yellow)  and (blue > red)     and (blue > green)   then Result := $02A0FFA0;  // blue + yellow
        // note no case for red + green, as there's no good colour to choose for that case

        DM.LeagueTable.RecNo := oldpos;
        if oldeof then DM.LeagueTable.Next;  // cause EOF to be set back to True
    end;

    // Build a list of games over a specified date/time range, showing all the teams in that game on a single row.
    procedure BuildGamesList(From, Too: TDateTime);
    var i, j, teamnum: Integer;
        teamname: string;
        index: Integer;
        thisgame, lastgame: TDateTime;
        teamslist: TList;
        teamentry: TStringList;
        maxteamcount, colcount: Integer;
        highid: string;
        highscore, highteamnum: Integer;
        report: TZoomReport;
        NewFrom: TDateTime;
    begin
        report := reports.Add('dummytitle', 'Game', 'right');
        teamslist := TList.Create;

        maxteamcount:= 0;
        lastgame    := -1;
        thisgame    := 0;
        try
            DM.LeagueTable.Close;
            DM.LeagueTable.IndexFieldNames := 'Game;ID';
            DM.LeagueTable.Open;
            DM.LeagueTable.FindNearest([From,'']);  // can't use a Locate here because I need an imperfect match
            NewFrom := DM.LeagueTable.FieldByName('Game').AsDateTime;

            while (not DM.LeagueTable.EOF) and (DM.LeagueTable.FieldByName('Game').AsDateTime <= Too) do begin  // loop through each game, and create a row for it
                thisgame := DM.LeagueTable.FieldByName('Game').AsDateTime;
                if Trunc(lastgame) < Trunc(thisgame) then begin  // we've crossed a date boundary
                    index := report.Rows.Add(TZRow.Create);  // write a row containing the new date
                    report.Rows[index].Add(FormatDateTime(ShortDateFormat, thisgame));
                end;  // if lastgame < thisgame
                lastgame := thisgame;

                index := report.Rows.Add(TZRow.Create);

                report.Rows[index].Add(FormatDateTime(ShortTimeFormat, thisgame));

                highscore   := -1000000;
                highteamnum := 0;
                highid      := '';
                while (not DM.LeagueTable.EOF) and (DM.LeagueTable.FieldByName('Game').AsDateTime = thisgame) do begin  // loop through each game, and create an entry for it
                    if StrToIntDef(DM.LeagueTable.FieldByName('ID').AsString, -1) = -1 then begin // this is a solo record
                        if highscore < DM.LeagueTable.FieldByName('Score').AsInteger then begin   // find the high scoring player
                            highscore   := DM.LeagueTable.FieldByName('Score').AsInteger;
                            highid      := DM.LeagueTable.FieldByName('ID').AsString;
                            highteamnum := StrToIntDef(DM.LeagueTable.FieldByName('ID2').AsString, 0)
                        end;
                    end else begin // this is a team record
                        teamnum := DM.LeagueTable.FieldByName('ID').AsInteger;
                        teamname := 'Team ' + IntToStr(teamnum);
                        for i := 0 to LeagueList.Count - 1 do
                            if LeagueList[i].TeamID = teamnum then
                                teamname := LeagueList[i].BuildTeamName;

                        teamentry := TStringList.Create;
                        teamentry.Add(teamname);
                        teamentry.Add(DM.LeagueTable.FieldByName('Score').AsString);
                        if (LeaguePoints.Count = 0) or (StrToIntDef(LeaguePoints[0], 0) = 0) then  // there are no victory points for this league
                            teamentry.Add('')
                        else
                            teamentry.Add(DM.LeagueTable.FieldByName('Points').AsString);
                        teamentry.Add(Format('$%.8x', [GetTeamColour(thisgame, teamnum)]));
                        teamslist.Add(teamentry);

                    end;  // team record

                    DM.LeagueTable.Next;
                end;  // while Game = thisgame

                if maxteamcount < teamslist.Count then
                    maxteamcount := teamslist.Count;

                BubbleSort(teamslist, CompareGames);

                for i := 0 to teamslist.Count - 1 do begin
                    report.Rows[index].Add('');
                    report.Rows[index].Add(TStringList(teamslist[i])[0], StringToColor(TStringList(teamslist[i])[3]));
                    report.Rows[index].Add(TStringList(teamslist[i])[1], StringToColor(TStringList(teamslist[i])[3]));
                    report.Rows[index].Add(TStringList(teamslist[i])[2], StringToColor(TStringList(teamslist[i])[3]));

                    report.Rows[index][report.Rows[index].Count - 3].BarCell := report.Rows[index].Count - 2;
                    report.Rows[index][report.Rows[index].Count - 2].BarCell := report.Rows[index].Count - 2;
                    report.Rows[index][report.Rows[index].Count - 1].BarCell := report.Rows[index].Count - 2;

                    TStringList(teamslist[i]).Free;
                end;
                teamslist.Clear;

//xxx                if LeaguePointsHigh <> 0 then begin // show the highscoring player
                        report.Rows[index].Add('');
                        report.Rows[index].Add(LeagueList.FindID(highid, MemberDBExists, DM), GetTeamColour(thisgame, highteamnum));
                        report.Rows[index].Add(IntToStr(highscore),                       GetTeamColour(thisgame, highteamnum));
//xxx                end;
            end;  // while date/time <= Too
            if DateToStr(NewFrom) = DateToStr(thisgame) then begin  // this report is for games on a single day
                report.Title := LeagueTitle + ' Games for ' + DateToStr(NewFrom);
                report.Rows.Delete(0);     // the first entry in rows is a date line; since there's only one date for the whole report, we can delete it.
            end else  // this report is for games over multiple days
                report.Title := LeagueTitle + ' Games from ' + DateToStr(NewFrom) + ' to ' + DateToStr(thisgame);

            colcount := maxteamcount * 4;

//xxx            if LeaguePointsHigh <> 0 then begin  // there is a highscore entry at the end of each row
                for i := 0 to report.Rows.Count - 1 do begin
                    while (report.Rows[i].Count > 1) and (report.Rows[i].Count < colcount + 1) do begin  // this game has less teams than the max; so pad with blanks
                        for j := 1 to 4 do
                            report.Rows[i].Insert(report.Rows[i].Count - 3, TZRow.Create);
                    end;
                end;
//xxx            end;
            for i := 1 to maxteamcount do begin  // set up the Headings text, to cater for however many columns the report has turned out to be
                report.Columns.Add('', 'left');
                report.Columns.Add('Team', 'right');
                report.Columns.Add('Score', 'right');
                if (LeaguePoints.Count = 0) or (StrToIntDef(LeaguePoints[0], 0) = 0) then  // there are no victory points for this league
                    report.Columns.Add('', 'right')
                else
                    report.Columns.Add('Pts', 'right');
            end;

//xxx            if LeaguePointsHigh <> 0 then begin // set up Headings text to show the highscoring player
                report.Columns.Add('', 'left');
                report.Columns.Add('Best player', 'left');
                report.Columns.Add('Score', 'right');
//xxx            end;
        finally
            DM.LeagueTable.Close;
            DM.LeagueTable.IndexName := '';
            teamslist.Free;
        end;
    end;

    // Build a list of games over a specified date/time range, showing all the teams in that game on a single row.
    procedure BuildGameGrid(From, Too: TDateTime);
    var i, j: Integer;
        thisgame: TDateTime;
        totalscore, totalpoints: Integer;
        report: TZoomReport;
        NewFrom: TDateTime;
    begin
        report := reports.Add('dummytitle', 'Team', 'left');

        thisgame    := 0;
        try
            DM.LeagueTable.Close;
            DM.LeagueTable.IndexFieldNames := 'Game;ID';
            DM.LeagueTable.Open;
            DM.LeagueTable.FindNearest([From,'']);  // can't use a Locate here because I need an imperfect match
            NewFrom := DM.LeagueTable.FieldByName('Game').AsDateTime;

            while (not DM.LeagueTable.EOF) and (DM.LeagueTable.FieldByName('Game').AsDateTime <= Too) do begin  // loop through each game, and create an entry for it
                thisgame := DM.LeagueTable.FieldByName('Game').AsDateTime;
                report.Columns.Add(DateTimeToStr(thisgame), 'right');  // add a column for this game
                if (LeaguePoints.Count > 0) and (StrToIntDef(LeaguePoints[0], 0) <> 0) then begin  // add a column for victory points for this game
                    report.Columns.Add('', 'right');
                end;
                report.Columns.Add('', 'left');  // add a spacer column

                while (not DM.LeagueTable.EOF) and (DM.LeagueTable.FieldByName('Game').AsDateTime = thisgame) do
                    DM.LeagueTable.Next;
            end;  // while in date/time range From .. Too
            report.Columns.Add('Total', 'right');  // add one last column for the team total score
            if (LeaguePoints.Count > 0) and (StrToIntDef(LeaguePoints[0], 0) <> 0) then begin  // add a column for victory points for this game
                report.Columns.Add('Pts', 'right');  // add one laster column for the team total points
            end;
            for i := 0 to LeagueList.Count - 1 do begin  // for each League team, create a row
                report.Rows.Add(TZRow.Create);
                totalscore := 0;
                totalpoints := 0;

                report.Rows[i].Add(LeagueList[i].BuildTeamName);  // set up team name

                for j := 1 to report.Columns.Count - 3 do  // for each game, create a cell
                    if Length(report.Columns[j].Heading) > 1 then begin  // this team played in this game, so show their score
                        if DM.LeagueTable.Locate('Game;ID', VarArrayOf([StrToDateTime(report.Columns[j].Heading), Format('%4.4d', [LeagueList[i].TeamID])]), []) then begin
                            report.Rows[i].Add(DM.LeagueTable.FieldByName('Score').AsString, GetTeamColour(StrToDateTime(report.Columns[j].Heading), LeagueList[i].TeamID));
                            report.Rows[i][report.Rows[i].Count - 1].BarCell := report.Rows[i].Count - 1;
                            if (LeaguePoints.Count > 0) and (StrToIntDef(LeaguePoints[0], 0) <> 0) then begin  // add a column for victory points for this game
                                report.Rows[i].Add(DM.LeagueTable.FieldByName('Points').AsString, GetTeamColour(StrToDateTime(report.Columns[j].Heading), LeagueList[i].TeamID));
                                report.Rows[i][report.Rows[i].Count - 1].BarCell := report.Rows[i].Count - 2;
                            end;
                            totalscore := totalscore + DM.LeagueTable.FieldByName('Score').AsInteger;
                            totalpoints := totalpoints + DM.LeagueTable.FieldByName('Points').AsInteger;
                        end else begin  // this team did not play in this game, so show empty spacers
                            report.Rows[i].Add('');
                            if (LeaguePoints.Count > 0) and (StrToIntDef(LeaguePoints[0], 0) <> 0) then  // add a column for victory points for this game
                                report.Rows[i].Add('');
                        end;
                        report.Rows[i].Add('');  // spacer cell
                    end;
                report.Rows[i].Add(IntToStr(totalscore));
                if (LeaguePoints.Count > 0) and (StrToIntDef(LeaguePoints[0], 0) <> 0) then begin  // add a column for victory points for this game
                    report.Rows[i].Add(IntToStr(totalpoints));
                end;
            end;

            if DateToStr(NewFrom) = DateToStr(thisgame) then begin  // this report is for games on a single day
                report.Title := LeagueTitle + ' Games for ' + DateToStr(NewFrom);
                for j := 1 to report.Columns.Count - 3 do
                    if Length(report.Columns[j].Heading) > 1 then
                        report.Columns[j].Heading := FormatDateTime(ShortTimeFormat, StrToDateTime(report.Columns[j].Heading));  // convert date/time headings to just short time
            end else  // this report is for games over multiple days
                report.Title := LeagueTitle + ' Games from ' + DateToStr(NewFrom) + ' to ' + DateToStr(thisgame);

            BubbleSort(report.Rows, CompareGrid);
        finally
            DM.LeagueTable.Close;
            DM.LeagueTable.IndexName := '';
        end;
    end;

    // Take lists of items to show on the scoreboard, and show 'em, by creating records in StatsTable appropriately.
    procedure ShowOnScoreboard(reports: TZoomReports);
    var i, j: Integer;
    begin
        try
            if not CleanStats(900) then exit;

            for i := 0 to reports.Count - 1 do
                with reports[i] do begin
                    if Pos(' Team Ladder ', Title) <> 0 then begin
                        if Columns[2].Heading = '' then
                            WriteStatsLine(VarArrayOf([999, i + 60, 4, '', '', 0, 0, 100, 0, 0, 0, Now, 'TEAM LADDER', 1, 0]))
                        else
                            WriteStatsLine(VarArrayOf([999, i + 60, 4, '', '', 0, 0, 100, 0, 0, 0, Now, 'TEAM LADDER("Acc" is leag pts)', 1, 0]));
                        for j := 0 to Min(Rows.Count, 20) - 1 do  // loop through each item on the ladder, and create a StatsTable entry for it.
                            if Columns[2].Heading = '' then
                                WriteStatsLine(VarArrayOf([999, j * 3, j div 20 + 1, '', Rows[j][1].Text, 0, 0, 100,
                                               StrToIntDef(Rows[j][3].Text, 0), j + 1, 0, Now, '', 1, 1]))
                            else
                                WriteStatsLine(VarArrayOf([999, j * 3, j div 20 + 1, '', Rows[j][1].Text, 0, 0, 100,
                                               StrToIntDef(Rows[j][3].Text, 0), j + 1, Integer(Round(StrToFloatDef(Rows[j][2].Text, 0.0) * 10)), Now, '', 1, 1]));
                    end else if Pos(' Solo Ladder ', Title) <> 0 then begin
                        WriteStatsLine(VarArrayOf([999, i + 60, 4, '', '', 0, 0, 100, 0, 0, 0, Now, 'SOLO LADDER ("Acc" is av rank)', 1, 0]));
                        for j := 0 to Min(Rows.Count, 60 - i * 20) - 1 do  // loop through each item on the ladder, and create a StatsTable entry for it.
                            WriteStatsLine(VarArrayOf([999, (j mod 20) * 3 + i + j div 20, j div 20 + i + 1, '', Rows[j][1].Text, 0, 0, 100,
                                           StrToIntDef(Rows[j][3].Text, 0), j + 1, Integer(Round(StrToFloatDef(Rows[j][4].Text, 0.0) * 10)), Now, '', 1, 1]))
                    end else
                        WriteStatsLine(VarArrayOf([999, i + 60, 4, '', '', 0, 0, 100, 0, 0, 0, Now, '', 1, 0]));
                end;
            for i := reports.Count to 2 do  // loop through any remaining colours and create dummy "team" entries
                WriteStatsLine(VarArrayOf([999, i + 60, 4, '', '', 0, 0, 100, 0, 0, 0, Now, '', 1, 0]));
        finally
            DM.StatsTable.Close;
            DM.StatsTable.ReadOnly := True;

            SendUDP(12005, 'PROCESSSCORES,' + IntToStr(999) + ',ONCE');
        end;
    end;

    // Take a list of items to show on this screen, and show 'em, by drawing on the canvas.
    // Called by ShowLeagueLadderClick and ShowSoloLadderClick.
    procedure ShowOnScreen(reports: TZoomReports);
    begin
        if LadderForm = nil then begin
            LadderForm := TLadderForm.Create(Application);
            LadderForm.Top := 0;
            LadderForm.Height := Screen.Height - 28;
            if OwnerForm.Left > Screen.Width - (OwnerForm.Left + OwnerForm.Width) then begin  // put the report to the left of Torn's main window
                LadderForm.Left := 0;
                LadderForm.Width := OwnerForm.Left;
            end else begin  // put the report to the right of Torn's main window
                LadderForm.Left := OwnerForm.Left + OwnerForm.Width;
                LadderForm.Width := Screen.Width - (OwnerForm.Left + OwnerForm.Width);
            end;
        end;
        LadderForm.Image1.Picture.Bitmap.Height := LadderForm.Image1.Height;
        LadderForm.Image1.Picture.Bitmap.Width  := LadderForm.Image1.Width;

        reports.Show(LadderForm.Image1.Canvas, 0, 0, LadderForm.Image1.Width, LadderForm.Image1.Height);
        LadderForm.Show;
    end;

    // Take a list of items to show on this screen, and show 'em, by drawing on the canvas.
    // Called by ShowLeagueLadderClick and ShowSoloLadderClick.
    procedure ShowOnPrinter(reports: TZoomReports);
    begin
        if not PrintDialog.Execute then Exit;

        with Printer do begin
            BeginDoc;
            Title := 'Torn report';
            reports.Show(Canvas, PageWidth div 10, PageHeight div 10, PageWidth * 9 div 10, PageHeight * 9 div 10);
            EndDoc;
        end;
    end;

    // Take a list of items to show on this screen, and show 'em, by drawing on the canvas.
    procedure SaveAsHtml(reports: TZoomReports);
    var F: TextFile;
    begin
        if not SaveDialog.Execute then Exit;

        AssignFile(F, SaveDialog.FileName);
        reports.SaveAsHtml(F);
    end;

begin  //--- ReportLeagueClick ---
    if ReportForm = nil then
        ReportForm := TReportForm.Create(Application);

    ReportForm.DateFrom.DateTime := LastGameDate;
    ReportForm.DateTo.DateTime   := ReportForm.DateFrom.DateTime;

    reports := TZoomReports.Create;
    try
        if ReportForm.ShowModal = mrOK then begin
            Screen.Cursor := crAppStart;
            try
                From := ReportForm.DateFrom.Date + ReportForm.TimeFrom.Time;
                Too  := ReportForm.DateTo.Date + ReportForm.TimeTo.Time;

                if ReportForm.TeamLadder.Checked then BuildTeamLadder(ReportForm.ScaleGames.Checked, ReportForm.TeamWithinRange.Checked, From, Too);
                if ReportForm.SoloLadder.Checked then BuildSoloLadder(ReportForm.DropWorst.Value, ReportForm.DropBest.Value, ReportForm.GamesPercent.Checked, ReportForm.SoloWithinRange.Checked, From, Too);
                if ReportForm.Games.Checked      then BuildGamesList(From, Too);
                if ReportForm.GameGrid.Checked   then BuildGameGrid (From, Too);

                if ReportForm.ToScreen.Checked     then ShowOnScreen(reports);
                if ReportForm.ToScoreboard.Checked then ShowOnScoreboard(reports);
            finally
                Screen.Cursor := crDefault;
            end;
            if ReportForm.ToHtml.Checked           then SaveAsHtml(reports);
            if ReportForm.ToPrinter.Checked        then begin
                if ReportForm.Portrait.Checked then
                    Printer.Orientation := poPortrait
                else
                    Printer.Orientation := poLandscape;
                ShowOnPrinter(reports);
            end;
        end;
    finally
        reports.Free;
    end;
end;
*)
end.
