unit TornSplash;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TSplash = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    VersionLabel: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure VersionLabelDblClick(Sender: TObject);
  end;

var Splash: TSplash;

implementation

uses TornMain;
{$R *.DFM}

function GetEXEInfo(sInfo: String): String;
var
  S: string;
  sTmpVersion: string;
  Len: DWORD;
  n: DWORD;
  Value: PChar;
  Buf: PChar;
begin
  S := Application.ExeName;
  n := GetFileVersionInfoSize(PChar(S),n);
  Result := '';

  if n > 0 then begin
    SetLength(sTmpVersion, 200);
    Value := @sTmpVersion;
    Buf := AllocMem(n);
    GetFileVersionInfo(PChar(S), 0, n, Buf);
    // $0409 = English (American) "found in Project/Options/Version Info/Language"
    if VerQueryValue(Buf, PChar('StringFileInfo\040904E4\' + sInfo), Pointer(Value), Len) then
        Result := Value;

    FreeMem(Buf,n);
  end;
end;

procedure TSplash.FormCreate(Sender: TObject);
var s: string;
begin
    s := GetEXEInfo('FileVersion');
    while Copy(s, Length(s) - 1, 999) = '.0' do
        s := Copy(s, 1, Length(s) - 2);
    VersionLabel.Caption := s;
end;

procedure TSplash.Button1Click(Sender: TObject);
begin
    Close;
end;

procedure TSplash.VersionLabelDblClick(Sender: TObject);
begin
    Memo2.Visible := not Memo2.Visible;
    BorderStyle := bsSizeable;
end;

end.
